## davix 0.6.7

=== CMakeLists.txt ===

## cmake build script for davix
project (davix)
cmake_minimum_required (VERSION 2.6)

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules/")
option(SHARED_LIBRARY "generate shared library" TRUE)
option(STATIC_LIBRARY  "generate static library" FALSE)


# build type
if(NOT CMAKE_BUILD_TYPE)
    message(STATUS "No build type selected, default to RelWithDebInfo")
    set(CMAKE_BUILD_TYPE "RelWithDebInfo")
endif(NOT CMAKE_BUILD_TYPE)

# load module
include(DefineInstallationPaths REQUIRED)
include(ReleaseDebugAutoFlags REQUIRED)
include(CMakeGeneratePkgConfig REQUIRED)
include(MacroAddDoxygen REQUIRED)
include(CMakeCXX11Support REQUIRED)
include(PortabilityGNUCheck REQUIRED)

#enable testing
INCLUDE(CTest)


set(OUTPUT_NAME_DAVIX "davix")
set(VERSION_MAJOR 0)
set(VERSION_MINOR 6)
set(VERSION_PATCH 7)
set(VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
set(VERSION_TAG "")


# components
option(ENABLE_TOOLS "enable or disable tools " TRUE)
option(ENABLE_HTML_DOCS "enable or disable generation of HTML documentation" FALSE)

# features
option(ENABLE_IPV6 "enable or disable IPv6 support " TRUE)
option(ENABLE_TCP_NODELAY "enable or disable tcp_nodelay" TRUE)
option(ENABLE_THIRD_PARTY_COPY "enable or disable third party copy support" FALSE)

# tests
option(UNIT_TESTS "enable or disable the unit tests" FALSE)
option(FUNCTIONAL_TESTS "enable or disable the functional tests" FALSE)
option(BENCH_TESTS "enable or disable the bench tests" FALSE)

# libs checks
find_package(Threads)

# openssl
find_package(OpenSSL)
SET(LIBSSL_PKG_LIBRARIES "${OPENSSL_LIBRARIES}")
SET(CRYPTO_PKG "")
SET(LIBSSL_PKG_INCLUDE_DIRS "${OPENSSL_INCLUDE_DIR}")

find_package(LibXml2)
set(LIBXML2_INCLUDE_DIRS ${LIBXML2_INCLUDE_DIR})

#const
set(HAVE_OPENSSL 1)
set(NE_HAVE_SSL 1)

add_subdirectory(deps)


#libuuid
find_package(uuid)


## general defs
add_definitions( -D_GNU_SOURCE)              # GNU source, import LFS, etc...
add_definitions( -D__DAVIX_INSIDE__)         # protection flag
add_definitions( -D__STDC_LIMIT_MACROS )     # C99 limit macros


set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CXX11_FLAG_ENABLE}")

include_directories( ${HTTPLIB_PKG_INCLUDE_DIRS} ${GLIB2_PKG_INCLUDE_DIRS} ${CMAKE_CURRENT_SOURCE_DIR}/deps ${CMAKE_CURRENT_SOURCE_DIR}/deps/libneon/src/ ${UUID_INCLUDE_DIRS} )
include_directories( ${CMAKE_SOURCE_DIR}/include/davix )
include_directories( ${CMAKE_SOURCE_DIR}/src/libs/)

add_subdirectory (src)
add_subdirectory (doc)

if(EXISTS "${CMAKE_SOURCE_DIR}/dist/CMakeLists.txt")
  add_subdirectory (dist)
endif()

add_subdirectory (test)
add_subdirectory (packaging)


#############################################################################
## headers
configure_file("${CMAKE_SOURCE_DIR}/include/davix/features.hpp.in"
               "${CMAKE_SOURCE_DIR}/include/davix/features.hpp"
               @ONLY)

install(DIRECTORY ${CMAKE_SOURCE_DIR}/include/davix/
        DESTINATION ${INCLUDE_INSTALL_DIR}/davix
        PATTERN "*.in" EXCLUDE)

##############################################################################
## Doc file
install(FILES RELEASE-NOTES LICENSE
                DESTINATION ${DOC_INSTALL_DIR}/) # install release notes


#######################################################
# Configure an 'uninstall' target
CONFIGURE_FILE(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)

ADD_CUSTOM_TARGET(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

=== deps/CMakeLists.txt ===
###
## compile dependencies of davix


IF(NOT HAVE_STRPTIME_H)
    SET(SRC_STRPTIME "${CMAKE_CURRENT_SOURCE_DIR}/strptime/strptime.c" PARENT_SCOPE)
ELSE(NOT HAVE_STRPTIME_H)
    SET(SRC_STRPTIME "" PARENT_SCOPE)
ENDIF(NOT HAVE_STRPTIME_H)


SET(SRC_SIMPLE_GET_PASS "${CMAKE_CURRENT_SOURCE_DIR}/simple_getpass/simple_get_pass.cpp" PARENT_SCOPE)
SET(SRC_STRING_UTILS_CPP "${CMAKE_CURRENT_SOURCE_DIR}/string_utils/stringutils.cpp" PARENT_SCOPE)


add_subdirectory(libneon)


if(NOT HAVE_SYSSOCKET_H)
set(SOCKET_PKG_LIBRARIES "ws2_32")
endif(NOT HAVE_SYSSOCKET_H)

SET(HTTPLIB_PKG_VERSION "0.29.0" PARENT_SCOPE)
SET(HTTPLIB_PKG_STATIC_LIB_PATH "${CMAKE_CURRENT_BINARY_DIR}/libneon/src/libneon.a")
SET(HTTPLIB_PKG_LIBRARIES ${HTTPLIB_PKG_STATIC_LIB_PATH} ${LIBSSL_PKG_LIBRARIES} ${LIBGSSAPI_PKG_LIBRARIES} ${LIBXML2_LIBRARIES} ${SOCKET_PKG_LIBRARIES} PARENT_SCOPE)
SET(HTTPLIB_PKG_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/libneon/src/  ${LIBXML2_INCLUDE_DIRS} ${LIBSSL_PKG_INCLUDE_DIRS}  ${LIBGSSAPI_PKG_INCLUDE_DIRS} PARENT_SCOPE)

=== src/CMakeLists.txt ===
# main file for src

FILE(GLOB src_davix
    "*.cpp" "neon/*.cpp" "status/*.cpp" "fileops/*.cpp"
    "params/*.cpp" "auth/*.cpp" "file/*.cpp" "deprecated/*.cpp"
    "request/*.cpp" "hooks/*.cpp" "modules/*.cpp" "utils/*.cpp" "xml/*.cpp"
)


include_directories("libs" ".")

configure_file(davix_internal_config.in ${CMAKE_CURRENT_BINARY_DIR}/davix_internal_config.hpp @ONLY)

include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})
link_directories(${HTTPLIB_PKG_LIBRARY_DIR} ${CRYPTO_PKG_LIBRARY_DIR}
                                        ${LIBXML2_PKG_LIBRARY_DIR} )

add_subdirectory(modules/copy)
add_subdirectory(libs)

if(ENABLE_TOOLS)
  add_subdirectory(tools)
endif()

LIST(APPEND SRC_DAVIX_FULL ${src_davix} ${src_datetime}
                           ${SRC_STRPTIME} ${SRC_MEMPCPY} ${SRC_STRLCPY} ${SRC_STRING_UTILS_CPP}
                           ${SRC_BASE64} ${SRC_HMACSHA1})


add_definitions(${HTTPLIB_PKG_CFLAGS} )

if(SHARED_LIBRARY)
add_library(libdavix  SHARED ${SRC_DAVIX_FULL} )
add_dependencies(libdavix neon)


target_link_libraries(libdavix  alibxx_core ${HTTPLIB_PKG_LIBRARIES} ${CRYPTO_PKG_LIBRARIES}
                                ${CMAKE_THREAD_LIBS_INIT} ${SOCKET_PKG_LIBRARIES} ${UUID_LIBRARIES})

set_target_properties(libdavix PROPERTIES
                            VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}
                            SOVERSION ${VERSION_MAJOR}
                            CLEAN_DIRECT_OUTPUT 1
                            OUTPUT_NAME ${OUTPUT_NAME_DAVIX})

install(TARGETS libdavix
             DESTINATION ${LIB_INSTALL_DIR} )

add_PkgConfigFile_for_Library("davix.pc" libdavix
                               HEADER_DIRS "davix"
                               CFLAGS " -D_FILE_OFFSET_BITS=64 "
                               DESCRIPTION "Libdavix, IO library for HTTP based protocols"
                               )
#install pkgconfig
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/davix.pc
        DESTINATION ${PKGCONFIG_FILES_DIR} )

endif(SHARED_LIBRARY)



if(STATIC_LIBRARY)

add_definitions(-DA_LIB_NAMESPACE=Davix)
FILE(GLOB src_alibxx_static "libs/alibxx/*/*.cpp")
add_library(libdavix_static  STATIC ${SRC_DAVIX_FULL} ${src_alibxx_static})

set_target_properties(libdavix_static PROPERTIES
                            OUTPUT_NAME ${OUTPUT_NAME_DAVIX})


install(TARGETS libdavix_static
             DESTINATION ${LIB_INSTALL_DIR} )

endif(STATIC_LIBRARY)

SET(davix_tool_common_src "${davix_tool_common_src_up}" PARENT_SCOPE)

=== test/functional/CMakeLists.txt ===
# main file for src


if(FUNCTIONAL_TESTS)

set(src_davix_test_lib "davix_test_lib.cpp")

#set( src_test_req "test_request.cpp")
#set( src_test_checksum "test_checksum.cpp")
#set( src_test_stat_session "test_stat_session.cpp")
#set( src_test_rw "davix_rw_test.cpp")
#set( src_test_opendir "test_opendir.cpp")
#set( src_test_opendir_partial "test_opendir_partial.cpp")
#set( src_test_opendirpp "test_opendirpp.cpp")
#set( src_test_directory "test_directory.cpp")
#set( src_test_auto_stat_mkdir_check "test_auto_stat_mkdir_check.cpp")
#set( src_test_auto_rmdir_unlink_delete "test_auto_rmdir_unlink_delete.cpp")
#set( src_test_valid_read_generic_simple "test_valid_read_generic_simple.cpp")
#set( src_test_valid_write_read_generic_simple "test_valid_write_read_generic_simple.cpp")
#set( src_test_valid_write_read_fd "test_valid_write_read_fd.cpp")
#set( src_test_valid_write_read_vector_simple "test_valid_write_read_vector_simple.cpp")
#set( src_tool_read_vector_simple "tool_read_vector_simple.cpp")
#set( src_tool_get_replicas "tool_get_replica_simple.cpp")
#set( src_test_mv "test_mv.cpp")

set( src_tester "tester.cpp")


add_library(test_davix_functional_lib STATIC ${src_davix_test_lib})

#add_executable(test_request ${src_test_req} )
#target_link_libraries(test_request libdavix  test_davix_functional_lib)

#add_executable(tool_read_vector_simple ${src_tool_read_vector_simple} )
#target_link_libraries(tool_read_vector_simple libdavix test_davix_functional_lib )

#add_executable(test_rw_fd ${src_test_valid_write_read_fd})
#target_link_libraries(test_rw_fd libdavix test_davix_functional_lib )

#add_executable(test_stat_auto_check ${src_test_auto_stat_mkdir_check})
#target_link_libraries(test_stat_auto_check libdavix test_davix_functional_lib)

#add_executable(test_checksum ${src_test_checksum})
#target_link_libraries(test_checksum libdavix test_davix_functional_lib)

#add_executable(test_auto_rmdir_unlink_delete ${src_test_auto_rmdir_unlink_delete})
#target_link_libraries(test_auto_rmdir_unlink_delete libdavix test_davix_functional_lib)

#add_executable(test_stat_session ${src_test_stat_session})
#target_link_libraries(test_stat_session libdavix test_davix_functional_lib)


#add_executable(test_rw ${src_test_rw})
#target_link_libraries(test_rw libdavix test_davix_functional_lib)

#add_executable(test_opendir ${src_test_opendir} )
#target_link_libraries(test_opendir libdavix test_davix_functional_lib)


#add_executable(test_directory ${src_test_directory} )
#target_link_libraries(test_directory libdavix test_davix_functional_lib)

#add_executable(test_opendir_partial ${src_test_opendir_partial})
#target_link_libraries(test_opendir_partial libdavix test_davix_functional_lib)

#add_executable(test_opendirpp ${src_test_opendirpp})
#target_link_libraries(test_opendirpp libdavix test_davix_functional_lib)

#add_executable(test_valid_read_generic_simple ${src_test_valid_read_generic_simple})
#target_link_libraries(test_valid_read_generic_simple libdavix test_davix_functional_lib)

#add_executable(test_valid_write_read_generic_simple ${src_test_valid_write_read_generic_simple})
#target_link_libraries(test_valid_write_read_generic_simple libdavix test_davix_functional_lib)

#add_executable(test_valid_write_read_vector_simple ${src_test_valid_write_read_vector_simple})
#target_link_libraries(test_valid_write_read_vector_simple libdavix test_davix_functional_lib)


#add_executable(tool_get_replicas ${src_tool_get_replicas})
#target_link_libraries(tool_get_replicas libdavix test_davix_functional_lib)

#add_executable(test_mv ${src_test_mv})
#target_link_libraries(test_mv libdavix test_davix_functional_lib)

add_executable(tester ${src_tester})
target_link_libraries(tester libdavix test_davix_functional_lib)

function(assert_not_empty var)
    if("${var}" STREQUAL "")
        message(FATAL_ERROR "variable must not be empty")
    endif()
endfunction(assert_not_empty)

function(matchparam param input)
    set(normalchars "a-zA-Z0-9/:.,")
    string(REGEX MATCH "${param} +(([${normalchars}]-| |[${normalchars}])+)" tmp ${input})
    if(NOT "${tmp}" STREQUAL "")
        string(REPLACE " " "" stripped ${CMAKE_MATCH_1})
        set(match ${stripped} PARENT_SCOPE)
    else()
        set(match "" PARENT_SCOPE)
    endif()
endfunction(matchparam)

function(paramexists param input)
    string(REGEX MATCH "${param}" tmp ${input})
    set(match ${tmp} PARENT_SCOPE)
endfunction(paramexists)

function(runtest params cmd)
    matchparam("--auth" ${params})
    set(auth ${match})
    assert_not_empty(${auth})

    matchparam("--uri" ${params})
    set(uri ${match})
    assert_not_empty(${uri})

    matchparam("--s3region" ${params})
    set(s3region ${match})

    paramexists("--s3alternate" ${params})
    set(s3alternate ${match})

    # build testname
    set(testname "${auth}")

    if(NOT "${s3region}" STREQUAL "")
        set(testname "${testname}|v4")
    endif()

    if(NOT "${s3alternate}" STREQUAL "")
        set(testname "${testname}|alt")
    endif()

    string(REPLACE " " "" cmdname ${cmd})
    set(testname "${testname}|${cmdname}|${uri}")

    set(arguments ${params})
    separate_arguments(arguments)
    add_test(${testname} tester ${arguments} "--command" "${cmd}")
endfunction(runtest)

function(preadvectest_single params ranges)
    runtest("${params}" "preadvec ${ranges} mergewindow=1")
    runtest("${params}" "preadvec ${ranges} mergewindow=1000")
    runtest("${params}" "preadvec ${ranges} nomulti,mergewindow=1000")
    runtest("${params}" "preadvec ${ranges} nomulti,mergewindow=1")
endfunction(preadvectest_single)

function(preadvectest params)
    preadvectest_single("${params}" "0-10,5-10,3-4,30-40,200-305,1000-1500")
    preadvectest_single("${params}" "0-10,5-10")
    preadvectest_single("${params}" "0-10,15-20")
endfunction(preadvectest)

function(fulltest params)
    runtest("${params}" "makeCollection")
    runtest("${params}" "populate 5")
    runtest("${params}" "listing 5")
    preadvectest("${params}")
    runtest("${params}" "movefile")
    runtest("${params}" "depopulate 3")
    runtest("${params}" "countfiles 2")
    runtest("${params}" "remove")
endfunction(fulltest)

function(s3tests params)
    runtest("${params}" "makeCollection")
    runtest("${params}" "populate 5")
    runtest("${params}" "listing 5")
    preadvectest("${params}")
    runtest("${params}" "movefile")
    runtest("${params}" "depopulate 3")
    runtest("${params}" "countfiles 2")
    runtest("${params}" "depopulate 5")
endfunction(s3tests)

function(test_with_proxy uri)
    fulltest("--auth proxy --uri ${uri}")
endfunction(test_with_proxy)

function(test_s3 accesskey secretkey uri region use_alt)
    set(params "--auth aws --s3accesskey ${accesskey} --s3secretkey ${secretkey} --uri ${uri}")
    if(NOT "${region}" STREQUAL "")
        set(params "${params} --s3region ${region}")
    endif()

    if(use_alt MATCHES "^alt$")
        set(params "${params} --s3alternate")
    elseif(NOT use_alt MATCHES "^noalt$")
        message(FATAL_ERROR "Invalid option passed to test_s3 for use_alt: ${use_alt}")
    endif()

    s3tests(${params})
endfunction(test_s3)

function(test_azure azurekey uri)
    set(params "--auth azure --azurekey ${azurekey} --uri ${uri}")

    runtest("${params}" "populate 5")
    runtest("${params}" "statdir")
    runtest("${params}" "listing 5")
    preadvectest("${params}")
    runtest("${params}" "depopulate 5")
endfunction(test_azure)


include(${CMAKE_SOURCE_DIR}/credentials/creds.cmake)


### DEPRECATED, to remove soon

function(test_dav_endpoint_ronly name cred)

    add_test(test_stat_session_${name} test_stat_session ${cred} ${name} ${name} ${name} ${name} ${name} ${name} ${name})
    add_test(test_opendir_${name} test_opendir ${name} ${cred})
  #  add_test(test_opendir_c_${name} test_opendir_c ${name} ${cred})
    add_test(test_opendirpp_${name} test_opendirpp ${name} ${cred})
  #  add_test(test_stat_c_${name} test_stat_c ${name} ${cred})
endfunction(test_dav_endpoint_ronly name cred)

function(test_dav_endpoint_rw name cred)

    add_test(test_stat_session_${name} test_stat_session ${cred} ${name} ${name} ${name} ${name} ${name} ${name} ${name})
    add_test(test_opendir_${name} test_opendir ${name} ${cred})
    add_test(test_opendirpp_${name} test_opendirpp ${name} ${cred})
    add_test(test_stat_auto_check_${name} test_stat_auto_check ${name} ${cred})
endfunction(test_dav_endpoint_rw name cred)

function(listdir_partial name size cred)
    add_test(test_opendir_partial_${name}  test_opendir_partial ${name} ${size} ${cred})
endfunction(listdir_partial name size cred)


function(test_collection name cred)
    add_test(test_directory_${name} test_directory ${name} ${cred})
endfunction(test_collection name cred)

function(test_valid_read_generic url cred)
    add_test(test_valid_read_generic_${url} test_valid_read_generic_simple ${url} ${cred})
endfunction(test_valid_read_generic url cred)

function(test_valid_delete_all url cred)
    add_test(test_auto_rmdir_unlink_delete_${url} test_auto_rmdir_unlink_delete ${url} ${cred})
endfunction(test_valid_delete_all url cred)


function(test_valid_write_read_generic url cred)
    add_test(test_valid_write_read_generic_simple_${url} test_valid_write_read_generic_simple ${url} ${cred})
    add_test(test_rw_fd_${url} test_rw_fd ${url} ${cred})
    add_test(test_valid_write_read_vector_simple_${url} test_valid_write_read_vector_simple ${url} ${cred})
endfunction(test_valid_write_read_generic url cred)

function(test_replica_listing_existing url cred)
   add_test(tool_get_replicas_${url} tool_get_replicas ${url} ${cred})
endfunction(test_replica_listing_existing url cred)

function(test_rename url cred)
    add_test(test_mv_${url} test_mv ${url} ${cred})
endfunction(test_rename url cred)

# include(ctest_functional.cmake)

endif(FUNCTIONAL_TESTS)

=== test/unit/CMakeLists.txt ===
# main file for src

if(UNIT_TESTS)

include_directories(${PROJECT_SOURCE_DIR}/src "." ${GTEST_INCLUDE_DIRS})
include_directories(${HEADER_RAPIDJSON})

## gtest
set(GTEST ${CMAKE_SOURCE_DIR}/deps/googletest/googletest )
set(GTEST_BINARY_DIR ${CMAKE_BINARY_DIR}/deps/googletest/googletest )

include_directories(${GTEST}/include)
add_subdirectory(${GTEST} ${GTEST_BINARY_DIR} )

## alibxx

file(GLOB src_alibxx alibxx/*.cpp)
file(GLOB src_neon neon/*.cpp)
file(GLOB src_datetime datetime/*.cpp)
file(GLOB src_credential credential/*.cpp)
file(GLOB src_context context/*.cpp)
file(GLOB src_session session/*.cpp)
file(GLOB src_parser xmlparser/*.cpp)
file(GLOB src_files files/*.cpp)
file(GLOB src_auth  auth/*.cpp)
file(GLOB src_parser  parser/*.cpp)

LIST(APPEND src_utils utils/utils_test.cpp ${SRC_STRING_UTILS_CPP})
LIST(APPEND src_httprequest sessionfactory/test_factory.cpp)


add_definitions( -DTEST_VALID_CERT="${TEST_CRED_PATH}" -DTEST_VALID_CERT_PASS="${TEST_CRED_PASS}")
add_executable(g_test_unit_davix_exe ${src_context} ${src_session} ${src_credential}
                ${src_httprequest} ${src_datetime} ${src_neon} ${src_parser} ${src_auth} ${src_utils} ${src_parser} ${SRC_BASE64}
                ${SRC_HMACSHA1} ${davix_tool_common_src} ${src_files} ${src_alibxx})

target_link_libraries(g_test_unit_davix_exe alibxx_core libdavix gtest gtest_main ${CMAKE_THREAD_LIBS_INIT} ${LIBSSL_PKG_LIBRARIES})
add_dependencies(g_test_unit_davix_exe libdavix)



add_test(g_test_unit_davix g_test_unit_davix_exe )

endif(UNIT_TESTS)

=== src/libs/alibxx/CMakeLists.txt ===
# libs CMakefile for A_LIB_NAMESPACE


SET(ALIBXX_SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR} CACHE STRING "ALIBXX src dir")


FILE(GLOB src_alibxx "${CMAKE_CURRENT_SOURCE_DIR}/*/*.cpp")

add_definitions( -fPIC)

if(SHARED_LIBRARY)
add_library(alibxx_core STATIC ${src_alibxx})
endif(SHARED_LIBRARY)

=== src/libs/datetime/CMakeLists.txt ===
# main file for src




FILE(GLOB _src_datetime "*.cpp")

SET(src_datetime ${_src_datetime} PARENT_SCOPE)

=== src/modules/copy/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

IF (ENABLE_THIRD_PARTY_COPY)
    INCLUDE     (CheckLibraryExists)

    pkg_check_modules(GSOAP_SSL_PKG    REQUIRED "gsoapssl++")

    FIND_PACKAGE(gSOAP REQUIRED)
    MESSAGE(STATUS "Using gsoapssl flags ${GSOAP_SSL_PKG_CFLAGS}")

    # Compile the WSDL for 1.1.0
    ADD_CUSTOM_COMMAND (OUTPUT typemap.dat
                        COMMAND cp ${CMAKE_CURRENT_SOURCE_DIR}/delegation/typemap.dat ${CMAKE_CURRENT_BINARY_DIR}/typemap.dat)

    ADD_CUSTOM_COMMAND (
        OUTPUT delegation1.h
        COMMAND ${GSOAP_WSDL2H} -j -s -I/usr/share/gsoap/import/ -o${CMAKE_CURRENT_BINARY_DIR}/delegation1.h ${CMAKE_CURRENT_SOURCE_DIR}/delegation/delegation-1.1.0.wsdl -qdelegation1
        DEPENDS typemap.dat)
    ADD_CUSTOM_COMMAND (
        OUTPUT delegation1C.cpp delegation1Client.cpp
        COMMAND ${GSOAP_SOAPCPP2} -L -C -x -w -I/usr/share/gsoap/import/ ${CMAKE_CURRENT_BINARY_DIR}/delegation1.h -pdelegation1 -qdelegation1
        DEPENDS delegation1.h)

    # Compile the WSDL for 2.0.0
    ADD_CUSTOM_COMMAND (
        OUTPUT delegation2.h
        COMMAND ${GSOAP_WSDL2H} -j -s -I/usr/share/gsoap/import/ -o${CMAKE_CURRENT_BINARY_DIR}/delegation2.h ${CMAKE_CURRENT_SOURCE_DIR}/delegation/delegation-2.0.0.wsdl -qdelegation2
        DEPENDS typemap.dat)
    ADD_CUSTOM_COMMAND (
        OUTPUT delegation2C.cpp delegation2Client.cpp
        COMMAND ${GSOAP_SOAPCPP2} -C -x -w -I/usr/share/gsoap/import/ ${CMAKE_CURRENT_BINARY_DIR}/delegation2.h -n
        DEPENDS delegation2.h)

    # Need to generate some utility functions in the global namespace
    ADD_CUSTOM_COMMAND (OUTPUT env.h
                        COMMAND touch env.h)
    ADD_CUSTOM_COMMAND (OUTPUT envC.cpp
                        COMMAND ${GSOAP_SOAPCPP2}  ${CMAKE_CURRENT_BINARY_DIR}/env.h -penv
                        DEPENDS env.h)

    # Includes
    INCLUDE_DIRECTORIES (${CMAKE_CURRENT_BINARY_DIR}
                         ${GSOAP_INCLUDE_DIR})

    # link
    LINK_DIRECTORIES( ${DAVIX_PKG_LIBRARY_DIRS})
    ADD_DEFINITIONS(${GSOAP_SSL_PKG_CFLAGS})

    # Build third party copy as a static library
    FILE(GLOB src_copy "*.cpp")
    FILE(GLOB src_dlg "delegation/*.cpp")

    ADD_LIBRARY (davix_copy SHARED ${src_copy} ${src_dlg}
                           ${CMAKE_CURRENT_BINARY_DIR}/delegation1C.cpp
                           ${CMAKE_CURRENT_BINARY_DIR}/delegation1Client.cpp
                           ${CMAKE_CURRENT_BINARY_DIR}/delegation2C.cpp
                           ${CMAKE_CURRENT_BINARY_DIR}/delegation2Client.cpp
                           ${CMAKE_CURRENT_BINARY_DIR}/envC.cpp)

    TARGET_LINK_LIBRARIES(davix_copy libdavix
                                     ${GSOAP_SSL_PKG_LIBRARIES}
                                     z)

    SET_TARGET_PROPERTIES(davix_copy PROPERTIES
                            VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}
                            SOVERSION ${VERSION_MAJOR}
                            CLEAN_DIRECT_OUTPUT 1
                            OUTPUT_NAME "davix_copy")

    INSTALL(TARGETS davix_copy
             DESTINATION ${LIB_INSTALL_DIR})

    add_PkgConfigFile_for_Library("davix_copy.pc" davix_copy
                               HEADER_DIRS "davix"
                               CFLAGS " -D_FILE_OFFSET_BITS=64 "
                               DESCRIPTION "Davix, High level WebDav/HTTP library. Third party copy library."
                               )

    INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/davix_copy.pc
            DESTINATION ${PKGCONFIG_FILES_DIR})

ENDIF (ENABLE_THIRD_PARTY_COPY)

=== debian/changelog ===
davix (0.6.7-1) unstable; urgency=medium

  * Update to version 0.6.7
  * Migrate to dbgsym packages
  * Fix warnings about code examples that can not be parsed in documentation
  * Remove .doctrees directory from documentation

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Thu, 22 Feb 2018 13:57:34 +0100

=== debian/control ===
Source: davix
Priority: optional
Maintainer: Mattias Ellert <mattias.ellert@physics.uu.se>
Build-Depends: debhelper (>= 9), cmake, libxml2-dev, libssl-dev, gsoap, libgtest-dev, abi-compliance-checker, pkg-config, doxygen, python3-sphinx, python3-sphinx-rtd-theme, zlib1g-dev, uuid-dev
Standards-Version: 4.1.3
Section: net
Vcs-Browser: https://salsa.debian.org/ellert/davix
Vcs-Git: https://salsa.debian.org/ellert/davix.git
Homepage: http://dmc.web.cern.ch/projects/davix/home

Package: davix
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, libdavix0v5 (= ${binary:Version})
Description: Toolkit for http based file management
 Davix is a toolkit designed for file operations with http based protocols
 (WebDav, Amazon S3, ...).

Package: libdavix0v5
Section: libs
Architecture: any
Multi-Arch: same
Replaces: libdavix0 (<< 0.4.1-2~)
Breaks: libdavix0 (<< 0.4.1-2~)
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Runtime library for davix
 Library for davix. Davix is a toolkit designed for file operations with
 http based protocols (WebDav, Amazon S3, ...).

Package: davix-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libdavix0v5 (= ${binary:Version})
Description: Development files for davix
 Development files for davix. Davix is a toolkit designed for file operations
 with http based protocols (WebDav, Amazon S3, ...).

Package: davix-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Pre-Depends: dpkg (>= 1.17.14)
Depends: ${misc:Depends}, sphinx-rtd-theme-common, libjs-jquery, libjs-underscore
Description: Documentation for davix
 Documentation and examples for davix. Davix is a toolkit designed for file
 operations with Http based protocols (WebDav, Amazon S3, ...).

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

-include /usr/share/dpkg/buildflags.mk

CFLAGS += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

export CFLAGS CXXFLAGS LDFLAGS

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@

override_dh_auto_configure:
	# Remove bundled stuff
	rm -rf deps/strptime
	rm -rf test/pywebdav
	rm -rf doc/sphinx/_themes/sphinx_rtd_theme
	# Debian's gtest is not precompiled - link source
	ln -fs /usr/src/gtest deps/googletest/googletest
	dh_auto_configure -- -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" \
		-DUNIT_TESTS=TRUE \
		-DGTEST_EXTERNAL=TRUE \
		-DENABLE_HTML_DOCS=TRUE \
		-DENABLE_THIRD_PARTY_COPY=TRUE

override_dh_auto_build:
	dh_auto_build -- all doc

override_dh_install:
	rm debian/tmp/usr/share/doc/davix/LICENSE
	rm -rf debian/tmp/usr/include/gtest
	rm debian/tmp/usr/lib/libgtest.a
	rm debian/tmp/usr/lib/libgtest_main.a
	rm -rf debian/tmp/usr/share/doc/davix/html/.doctrees
	rm -rf debian/tmp/usr/share/doc/davix/html/_static/css
	ln -s /usr/share/sphinx_rtd_theme/static/css \
	   debian/tmp/usr/share/doc/davix/html/_static/css
	rm -rf debian/tmp/usr/share/doc/davix/html/_static/fonts
	ln -s /usr/share/sphinx_rtd_theme/static/fonts \
	   debian/tmp/usr/share/doc/davix/html/_static/fonts
	rm -rf debian/tmp/usr/share/doc/davix/html/_static/js
	ln -s /usr/share/sphinx_rtd_theme/static/js \
	   debian/tmp/usr/share/doc/davix/html/_static/js
	rm debian/tmp/usr/share/doc/davix/html/_static/jquery.js
	ln -s /usr/share/javascript/jquery/jquery.js \
	   debian/tmp/usr/share/doc/davix/html/_static/jquery.js
	rm debian/tmp/usr/share/doc/davix/html/_static/underscore.js
	ln -s /usr/share/javascript/underscore/underscore.js \
	   debian/tmp/usr/share/doc/davix/html/_static/underscore.js
	dh_install
	dh_missing --fail-missing

override_dh_strip:
	dh_strip --dbgsym-migration='davix-dbg (<< 0.6.7), libdavix-dbg (<< 0.6.7)'

override_dh_auto_clean:
	rm -f deps/googletest/googletest
	rm -f include/davix/features.hpp
	dh_auto_clean

override_dh_auto_test:
	( cd obj-* ; make abi-check )
	dh_auto_test -- ARGS+="-V -T Test"

## davix 0.6.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -29,7 +29,7 @@
 set(OUTPUT_NAME_DAVIX "davix")
 set(VERSION_MAJOR 0)
 set(VERSION_MINOR 6)
-set(VERSION_PATCH 7)
+set(VERSION_PATCH 8)
 set(VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
 set(VERSION_TAG "")

=== test/unit/CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,6 @@
 if(UNIT_TESTS)
 
 include_directories(${PROJECT_SOURCE_DIR}/src "." ${GTEST_INCLUDE_DIRS})
-include_directories(${HEADER_RAPIDJSON})
 
 ## gtest
 set(GTEST ${CMAKE_SOURCE_DIR}/deps/googletest/googletest )
@@ -32,9 +31,9 @@
 add_definitions( -DTEST_VALID_CERT="${TEST_CRED_PATH}" -DTEST_VALID_CERT_PASS="${TEST_CRED_PASS}")
 add_executable(g_test_unit_davix_exe ${src_context} ${src_session} ${src_credential}
                 ${src_httprequest} ${src_datetime} ${src_neon} ${src_parser} ${src_auth} ${src_utils} ${src_parser} ${SRC_BASE64}
-                ${SRC_HMACSHA1} ${davix_tool_common_src} ${src_files} ${src_alibxx})
+                ${SRC_HMACSHA1} ${src_files} ${src_alibxx})
 
-target_link_libraries(g_test_unit_davix_exe alibxx_core libdavix gtest gtest_main ${CMAKE_THREAD_LIBS_INIT} ${LIBSSL_PKG_LIBRARIES})
+target_link_libraries(g_test_unit_davix_exe alibxx_core davix_tool_lib libdavix gtest gtest_main ${CMAKE_THREAD_LIBS_INIT} ${LIBSSL_PKG_LIBRARIES})
 add_dependencies(g_test_unit_davix_exe libdavix)

=== debian/changelog ===
davix (0.6.8-1) unstable; urgency=medium

  * Update to version 0.6.8
  * Drop patches davix-straight-quotes-in-code-example.patch and
    davix-spell.patch (accepted upstream)
  * Unbundle new dependency rapidjson

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Wed, 27 Jun 2018 10:15:57 +0200

davix (0.6.7-4) unstable; urgency=medium

  * Don't run abi-check test - not compatible with GCC 8 (Closes: #897735)

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Mon, 07 May 2018 16:38:41 +0200

davix (0.6.7-3) unstable; urgency=medium

  * Adjust Build-Depends due to googletest package split
  * Fix some inconsistencies in the precompiler macro names

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Thu, 26 Apr 2018 13:20:23 +0200

davix (0.6.7-2) unstable; urgency=medium

  * Use precompiled gtest library now that Debian provides a sane googletest
    package (Closes: #896453)

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Tue, 24 Apr 2018 09:29:52 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Source: davix
 Priority: optional
 Maintainer: Mattias Ellert <mattias.ellert@physics.uu.se>
-Build-Depends: debhelper (>= 9), cmake, libxml2-dev, libssl-dev, gsoap, libgtest-dev, abi-compliance-checker, pkg-config, doxygen, python3-sphinx, python3-sphinx-rtd-theme, zlib1g-dev, uuid-dev
-Standards-Version: 4.1.3
+Build-Depends: debhelper (>= 9), cmake, libxml2-dev, libssl-dev, gsoap, libgtest-dev (>= 1.8.0-7), pkg-config, doxygen, python3-sphinx, python3-sphinx-rtd-theme, zlib1g-dev, uuid-dev, rapidjson-dev
+Standards-Version: 4.1.4
 Section: net
 Vcs-Browser: https://salsa.debian.org/ellert/davix
 Vcs-Git: https://salsa.debian.org/ellert/davix.git

=== debian/rules ===
--- 
+++ 
@@ -16,13 +16,15 @@
 override_dh_auto_configure:
 	# Remove bundled stuff
 	rm -rf deps/strptime
+	rm -rf src/libs/rapidjson
 	rm -rf test/pywebdav
 	rm -rf doc/sphinx/_themes/sphinx_rtd_theme
-	# Debian's gtest is not precompiled - link source
-	ln -fs /usr/src/gtest deps/googletest/googletest
+	# Create empty googletest directory
+	mkdir -p deps/googletest/googletest
+	# Symlink to system rapidjson
+	ln -s /usr/include/rapidjson src/libs/rapidjson
 	dh_auto_configure -- -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" \
 		-DUNIT_TESTS=TRUE \
-		-DGTEST_EXTERNAL=TRUE \
 		-DENABLE_HTML_DOCS=TRUE \
 		-DENABLE_THIRD_PARTY_COPY=TRUE
 
@@ -31,9 +33,6 @@
 
 override_dh_install:
 	rm debian/tmp/usr/share/doc/davix/LICENSE
-	rm -rf debian/tmp/usr/include/gtest
-	rm debian/tmp/usr/lib/libgtest.a
-	rm debian/tmp/usr/lib/libgtest_main.a
 	rm -rf debian/tmp/usr/share/doc/davix/html/.doctrees
 	rm -rf debian/tmp/usr/share/doc/davix/html/_static/css
 	ln -s /usr/share/sphinx_rtd_theme/static/css \
@@ -51,16 +50,17 @@
 	ln -s /usr/share/javascript/underscore/underscore.js \
 	   debian/tmp/usr/share/doc/davix/html/_static/underscore.js
 	dh_install
+
+override_dh_missing:
 	dh_missing --fail-missing
 
 override_dh_strip:
 	dh_strip --dbgsym-migration='davix-dbg (<< 0.6.7), libdavix-dbg (<< 0.6.7)'
 
 override_dh_auto_clean:
-	rm -f deps/googletest/googletest
 	rm -f include/davix/features.hpp
+	rm -rf src/libs/rapidjson
 	dh_auto_clean
 
 override_dh_auto_test:
-	( cd obj-* ; make abi-check )
 	dh_auto_test -- ARGS+="-V -T Test"

## davix 0.7.1

=== debian/changelog ===
davix (0.7.1-1) unstable; urgency=medium

  * Update to version 0.7.1

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Fri, 26 Oct 2018 14:31:09 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Priority: optional
 Maintainer: Mattias Ellert <mattias.ellert@physics.uu.se>
 Build-Depends: debhelper (>= 9), cmake, libxml2-dev, libssl-dev, gsoap, libgtest-dev (>= 1.8.0-7), pkg-config, doxygen, python3-sphinx, python3-sphinx-rtd-theme, zlib1g-dev, uuid-dev, rapidjson-dev
-Standards-Version: 4.1.4
+Standards-Version: 4.2.1
 Section: net
 Vcs-Browser: https://salsa.debian.org/ellert/davix
 Vcs-Git: https://salsa.debian.org/ellert/davix.git

=== debian/rules ===
--- 
+++ 
@@ -23,6 +23,23 @@
 	mkdir -p deps/googletest/googletest
 	# Symlink to system rapidjson
 	ln -s /usr/include/rapidjson src/libs/rapidjson
+	# Create version.cmake
+	version=$$(dpkg-parsechangelog -S version | cut -d- -f1) ; \
+	major=$$(echo $$version | cut -d. -f1) ; \
+	minor=$$(echo $$version | cut -d. -f2) ; \
+	patch=$$(echo $$version | cut -d. -f3) ; \
+	minip=$$(echo $$version | cut -d. -f4) ; \
+	sed -e "s!@VERSION_MAJOR@!$$major!" \
+	    -e "s!@VERSION_MINOR@!$$minor!" \
+	    -e "s!@VERSION_PATCH@!$$patch!" \
+	    -e "s!@VERSION_MINIPATCH@!$$minip!" \
+	    -e "s!@VERSION_FULL@!$$version!" \
+	    version.cmake.in > version.cmake
+	# Replace the genversion.py script with a no-op
+	# The script doesn't do anything outside a git checkout anyway and
+	# replacing it avoids a build dependency on python2
+	rm -f genversion.py
+	ln -s /bin/true genversion.py
 	dh_auto_configure -- -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" \
 		-DUNIT_TESTS=TRUE \
 		-DENABLE_HTML_DOCS=TRUE \
@@ -59,6 +76,8 @@
 
 override_dh_auto_clean:
 	rm -f include/davix/features.hpp
+	rm -f version.cmake
+	rm -f genversion.py
 	rm -rf src/libs/rapidjson
 	dh_auto_clean

## davix 0.7.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,6 +2,40 @@
 ## cmake build script for davix
 project (davix)
 cmake_minimum_required (VERSION 2.6)
+
+# Find the python executable to use during the build.
+find_package(PythonInterp REQUIRED)
+
+#-------------------------------------------------------------------------------
+# Regenerate include/davix/features.hpp and version.cmake at _build_ time
+#-------------------------------------------------------------------------------
+add_custom_target(GenerateVersionInfo ALL DEPENDS Version)
+add_custom_command(
+  OUTPUT Version
+  COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/genversion.py --template include/davix/features.hpp.in --out include/davix/features.hpp
+  COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/genversion.py --template version.cmake.in --out version.cmake
+  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
+)
+
+#-------------------------------------------------------------------------------
+# Regenerate version.cmake at _configure_ time. Important since the above
+# only regenerates it at compile time.
+#-------------------------------------------------------------------------------
+execute_process(
+  COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/genversion.py --template version.cmake.in --out version.cmake
+  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
+)
+
+#-------------------------------------------------------------------------------
+# Include version.cmake. Whenever the version changes, ie you commit or tag,
+# the following happens:
+# - Next time you run 'make', version.cmake is updated.
+# - The next 'make' will detect version.cmake was changed, and cmake will
+#   reconfigure itself.
+#
+# A bit hacky.
+#-------------------------------------------------------------------------------
+include(version.cmake REQUIRED)
 
 set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules/")
 option(SHARED_LIBRARY "generate shared library" TRUE)
@@ -27,12 +61,6 @@
 
 
 set(OUTPUT_NAME_DAVIX "davix")
-set(VERSION_MAJOR 0)
-set(VERSION_MINOR 6)
-set(VERSION_PATCH 8)
-set(VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
-set(VERSION_TAG "")
-
 
 # components
 option(ENABLE_TOOLS "enable or disable tools " TRUE)
@@ -44,8 +72,6 @@
 option(ENABLE_THIRD_PARTY_COPY "enable or disable third party copy support" FALSE)
 
 # tests
-option(UNIT_TESTS "enable or disable the unit tests" FALSE)
-option(FUNCTIONAL_TESTS "enable or disable the functional tests" FALSE)
 option(BENCH_TESTS "enable or disable the bench tests" FALSE)
 
 # libs checks
@@ -91,7 +117,6 @@
 endif()
 
 add_subdirectory (test)
-add_subdirectory (packaging)
 
 
 #############################################################################
@@ -106,7 +131,7 @@
 
 ##############################################################################
 ## Doc file
-install(FILES RELEASE-NOTES LICENSE
+install(FILES RELEASE-NOTES.md LICENSE
                 DESTINATION ${DOC_INSTALL_DIR}/) # install release notes

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # main file for src
 
 FILE(GLOB src_davix
-    "*.cpp" "neon/*.cpp" "status/*.cpp" "fileops/*.cpp"
+    "*.cpp" "neon/*.cpp" "core/*.cpp" "status/*.cpp" "fileops/*.cpp"
     "params/*.cpp" "auth/*.cpp" "file/*.cpp" "deprecated/*.cpp"
     "request/*.cpp" "hooks/*.cpp" "modules/*.cpp" "utils/*.cpp" "xml/*.cpp"
 )

=== src/libs/CMakeLists.txt ===
# libs CMakefile for third party deps

add_definitions(-DA_LIB_NAMESPACE=Davix)
add_subdirectory(alibxx)
add_subdirectory(datetime)





SET(src_vector_chunk ${src_vector_chunk} PARENT_SCOPE)
SET(src_crypto ${src_crypto} PARENT_SCOPE)
SET(src_datetime ${src_datetime} PARENT_SCOPE)

=== debian/changelog ===
davix (0.7.2-1) unstable; urgency=medium

  * Update to version 0.7.2

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Tue, 19 Feb 2019 11:46:50 +0100

davix (0.7.1-3) unstable; urgency=medium

  * Fix cmake config warning due to Python 3 incompatibility

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Thu, 08 Nov 2018 15:23:43 +0100

davix (0.7.1-2) unstable; urgency=medium

  * Split out a davix-tests package
  * Update the .shlibs file

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Sat, 03 Nov 2018 06:44:32 +0100

=== debian/control ===
--- 
+++ 
@@ -15,6 +15,16 @@
 Description: Toolkit for http based file management
  Davix is a toolkit designed for file operations with http based protocols
  (WebDav, Amazon S3, ...).
+
+Package: davix-tests
+Architecture: any
+Multi-Arch: foreign
+Replaces: davix (<< 0.7.1-2~)
+Breaks: davix (<< 0.7.1-2~)
+Depends: ${shlibs:Depends}, ${misc:Depends}, libdavix0v5 (= ${binary:Version})
+Description: Test suite for davix
+ Test suite for davix. Davix is a toolkit designed for file operations
+ with http based protocols (WebDav, Amazon S3, ...).
 
 Package: libdavix0v5
 Section: libs

=== debian/rules ===
--- 
+++ 
@@ -39,9 +39,8 @@
 	# The script doesn't do anything outside a git checkout anyway and
 	# replacing it avoids a build dependency on python2
 	rm -f genversion.py
-	ln -s /bin/true genversion.py
+	touch genversion.py
 	dh_auto_configure -- -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" \
-		-DUNIT_TESTS=TRUE \
 		-DENABLE_HTML_DOCS=TRUE \
 		-DENABLE_THIRD_PARTY_COPY=TRUE

## davix 0.7.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -35,7 +35,9 @@
 #
 # A bit hacky.
 #-------------------------------------------------------------------------------
-include(version.cmake REQUIRED)
+include(release.cmake REQUIRED)
+include(version.cmake)
+message("Configuring cmake for davix version: ${VERSION_FULL}")
 
 set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules/")
 option(SHARED_LIBRARY "generate shared library" TRUE)

=== debian/changelog ===
davix (0.7.4-1) unstable; urgency=medium

  * Update to version 0.7.4
  * Change to debhelper compat level 10
  * Add Build-Depends on libgsoap-dev due to gsoap packaging change

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Tue, 23 Jul 2019 19:34:45 +0200

davix (0.7.3-1) unstable; urgency=medium

  * Update to version 0.7.3

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Wed, 22 May 2019 11:43:26 +0200

=== debian/control ===
Source: davix
Priority: optional
Maintainer: Mattias Ellert <mattias.ellert@physics.uu.se>
Build-Depends:
 debhelper (>= 10),
 cmake,
 libxml2-dev,
 libssl-dev,
 gsoap,
 libgsoap-dev,
 libgtest-dev (>= 1.8.0-7),
 pkg-config,
 doxygen,
 python3-sphinx,
 python3-sphinx-rtd-theme,
 zlib1g-dev,
 uuid-dev,
 rapidjson-dev
Standards-Version: 4.4.0
Section: net
Vcs-Browser: https://salsa.debian.org/ellert/davix
Vcs-Git: https://salsa.debian.org/ellert/davix.git
Homepage: http://dmc.web.cern.ch/projects/davix/home

Package: davix
Architecture: any
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libdavix0v5 (= ${binary:Version})
Description: Toolkit for http based file management
 Davix is a toolkit designed for file operations with http based protocols
 (WebDav, Amazon S3, ...).

Package: davix-tests
Architecture: any
Multi-Arch: foreign
Replaces:
 davix (<< 0.7.1-2~)
Breaks:
 davix (<< 0.7.1-2~)
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libdavix0v5 (= ${binary:Version})
Description: Test suite for davix
 Test suite for davix. Davix is a toolkit designed for file operations
 with http based protocols (WebDav, Amazon S3, ...).

Package: libdavix0v5
Section: libs
Architecture: any
Multi-Arch: same
Replaces:
 libdavix0 (<< 0.4.1-2~)
Breaks:
 libdavix0 (<< 0.4.1-2~)
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Runtime library for davix
 Library for davix. Davix is a toolkit designed for file operations with
 http based protocols (WebDav, Amazon S3, ...).

Package: davix-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 libdavix0v5 (= ${binary:Version})
Description: Development files for davix
 Development files for davix. Davix is a toolkit designed for file operations
 with http based protocols (WebDav, Amazon S3, ...).

Package: davix-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Pre-Depends:
 dpkg (>= 1.17.14)
Depends:
 ${misc:Depends},
 sphinx-rtd-theme-common,
 libjs-jquery,
 libjs-underscore
Description: Documentation for davix
 Documentation and examples for davix. Davix is a toolkit designed for file
 operations with Http based protocols (WebDav, Amazon S3, ...).

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

%:
	dh $@

override_dh_auto_configure:
	# Remove bundled stuff
	rm -rf deps/googletest/googlemock/*
	rm -rf deps/googletest/googletest/*
	rm -rf deps/strptime
	rm -rf src/libs/rapidjson
	rm -rf test/pywebdav
	rm -rf doc/sphinx/_themes/sphinx_rtd_theme
	# Symlink to system rapidjson
	ln -s /usr/include/rapidjson src/libs/rapidjson
	dh_auto_configure -- -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" \
		-DENABLE_HTML_DOCS=TRUE \
		-DENABLE_THIRD_PARTY_COPY=TRUE

override_dh_auto_build:
	dh_auto_build -- all doc

override_dh_install:
	rm debian/tmp/usr/share/doc/davix/LICENSE
	rm -rf debian/tmp/usr/share/doc/davix/html/.doctrees
	rm -rf debian/tmp/usr/share/doc/davix/html/_static/css
	ln -s /usr/share/sphinx_rtd_theme/static/css \
	   debian/tmp/usr/share/doc/davix/html/_static/css
	rm -rf debian/tmp/usr/share/doc/davix/html/_static/fonts
	ln -s /usr/share/sphinx_rtd_theme/static/fonts \
	   debian/tmp/usr/share/doc/davix/html/_static/fonts
	rm -rf debian/tmp/usr/share/doc/davix/html/_static/js
	ln -s /usr/share/sphinx_rtd_theme/static/js \
	   debian/tmp/usr/share/doc/davix/html/_static/js
	rm debian/tmp/usr/share/doc/davix/html/_static/jquery.js
	ln -s /usr/share/javascript/jquery/jquery.js \
	   debian/tmp/usr/share/doc/davix/html/_static/jquery.js
	rm debian/tmp/usr/share/doc/davix/html/_static/underscore.js
	ln -s /usr/share/javascript/underscore/underscore.js \
	   debian/tmp/usr/share/doc/davix/html/_static/underscore.js
	dh_install

override_dh_missing:
	dh_missing --fail-missing

override_dh_strip:
	dh_strip --dbgsym-migration='davix-dbg (<< 0.6.7), libdavix-dbg (<< 0.6.7)'

override_dh_auto_clean:
	rm -rf src/libs/rapidjson
	dh_auto_clean

override_dh_auto_test:
	dh_auto_test -- ARGS+="-V -T Test"
